'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initApp = initApp;
exports.initApolloClient = initApolloClient;

var _apolloClient = require('../lib/apollo-client.js');

var _index = require('./index.js');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var app = null;

function createApp(options) {
  return new _index2.default(options);
}

// 初始化 app
function initApp(appOptions) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  // server side, 創建並返回一個 app
  if (typeof window === 'undefined') {
    return createApp(appOptions);
  }

  // client side, 創建並保留 app instance
  if (!app || options.force) {
    app = createApp(appOptions);
  }

  // client side, 返回之前保留的 app instance
  return app;
}

// 初始化 app.apolloClient
function initApolloClient(app, _ref) {
  var initialState = _ref.initialState,
      loginToken = _ref.loginToken;

  // 若 app 中還沒有 apolloClient
  if (!app.apolloClient) {
    // 創建 app.apolloClient
    app.apolloClient = (0, _apolloClient.createApolloClient)({
      initialState: initialState,
      loginToken: loginToken,
      graphqlUrl: app.getSetting('graphqlUrl') || app.absoluteUrl('graphql'),
      headerLoginTokenKey: app.getSetting('headerLoginTokenKey'),
      localStorageLoginTokenKey: app.getSetting('localStorageLoginTokenKey')
    });
  }
}