'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n      mutation methodInvoker ($message: JSON) {\n        methodInvoker (message: $message)\n      }\n    '], ['\n      mutation methodInvoker ($message: JSON) {\n        methodInvoker (message: $message)\n      }\n    ']);

exports.default = methodsModule;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _graphqlTag = require('graphql-tag');

var _graphqlTag2 = _interopRequireDefault(_graphqlTag);

var _ejson = require('vclass-lib/ejson');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function methodsModule(app) {
  _underscore2.default.extend(app.constructor.prototype, {
    // applyMethod 會返回 promose
    // 需要上層程式碼 try catch error
    applyMethod: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(name, args, callback) {
        var message, returnValue, exception;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                args = _ejson.EJSON.clone(args);

                // message 參數
                message = {
                  msg: 'method',
                  method: name,
                  params: args

                  // 運行 methodInvoker async function, 有錯誤時用變數 exception 記低
                };
                _context.prev = 2;
                _context.next = 5;
                return methodInvoker(this, message);

              case 5:
                returnValue = _context.sent;
                _context.next = 12;
                break;

              case 8:
                _context.prev = 8;
                _context.t0 = _context['catch'](2);

                console.log("Error invoking Method '" + name + "':", _context.t0.message);
                exception = _context.t0;

              case 12:
                if (!callback) {
                  _context.next = 15;
                  break;
                }

                callback(exception, returnValue);
                return _context.abrupt('return', undefined);

              case 15:
                if (!exception) {
                  _context.next = 17;
                  break;
                }

                throw exception;

              case 17:
                return _context.abrupt('return', returnValue);

              case 18:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[2, 8]]);
      }));

      function applyMethod(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return applyMethod;
    }(),


    // callMethod 返回 promise
    callMethod: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(name /* .. [arguments] .. callback */) {
        var args,
            callback,
            returnValue,
            _args2 = arguments;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                args = Array.prototype.slice.call(_args2, 1);
                // 偵測最後一個參數是否為 callback function

                if (args.length && typeof args[args.length - 1] === 'function') {
                  callback = args.pop();
                }
                // 交給 applyMethod 處理
                _context2.next = 4;
                return this.applyMethod(name, args, callback);

              case 4:
                returnValue = _context2.sent;
                return _context2.abrupt('return', returnValue);

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function callMethod(_x4) {
        return _ref2.apply(this, arguments);
      }

      return callMethod;
    }()
  });
}

// methodInvoker 返回 promise, 但 applyMethod function 會幫手 try catch error
var methodInvoker = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(app, message) {
    var result, msg;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return app.apolloClient.mutate({
              mutation: (0, _graphqlTag2.default)(_templateObject),
              variables: {
                message: message
              }
            });

          case 2:
            result = _context3.sent;


            // 讀取結果
            msg = result.data.methodInvoker;

            // 若結果格式不對

            if (!(msg === null || !msg.msg)) {
              _context3.next = 7;
              break;
            }

            console.log('discarding invalid message', msg);
            return _context3.abrupt('return');

          case 7:
            if (!(msg.msg === 'result')) {
              _context3.next = 11;
              break;
            }

            return _context3.abrupt('return', _result(app, msg));

          case 11:
            if (msg.msg === 'error') {
              _error(app, msg);
              // 若為不知名的 msg
            } else {
              console.log('discarding unknown message type', msg);
            }

          case 12:
            return _context3.abrupt('return', undefined);

          case 13:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function methodInvoker(_x5, _x6) {
    return _ref3.apply(this, arguments);
  };
}();

// _error 僅輸出錯誤訊息
var _error = function _error(app, msg) {
  console.log('Received error from server: ', msg.reason);
  if (msg.offendingMessage) {
    console.log('For: ', msg.offendingMessage);
  }
};

var _result = function _result(app, msg) {
  // 若 msg.error 有錯誤資訊
  if (_underscore2.default.has(msg, 'error')) {
    // throw app.Error, 會觸動 applyMethod 的 try catch,
    // 然後會交由 applyMethod 的 callback 處理 (或重新 throw error 交給上層程式碼處理)
    throw new app.Error(msg.error.error, msg.error.reason, msg.error.details);
  } else {
    // 沒有錯誤, 返回結果
    return msg.result;
  }
};