'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = appSettingsModule;

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

var _settings = require('../../lib/modules/settings.js');

var _settings2 = _interopRequireDefault(_settings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function appSettingsModule(app, ctx) {
  // server side 時, ctx.settings 包含來自 req server 的 settings
  // client side 時, ctx.settings 包含來自 props 的 settings (來自 ssr 或 oldApp.settings)
  ctx.settings = (0, _extend2.default)({}, ctx.settings || {}, {
    // add custom app settings here
  });

  // 整合 default settings
  (0, _settings2.default)(app, ctx);

  // 若此 module 執行於 getInitialProps, server side
  // 整合埋資料庫的 settings.app 到 app.settings.public
  // 放在 startup 是為是等待 server prepare 起動 local mongodb server
  if (typeof window === 'undefined' && ctx.req) {
    app.startup(function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var server, settings, appSettings;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                server = ctx.req.vclass.server;

                if (!server.collections.settings) {
                  _context.next = 6;
                  break;
                }

                _context.next = 4;
                return server.collections.settings.findOne({}, { fields: { app: 1 } });

              case 4:
                settings = _context.sent;

                if (settings) {
                  appSettings = settings.app || {};

                  (0, _extend2.default)(true, app.settings.public, appSettings);
                }

              case 6:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function extendSettingsFromDatabase() {
        return _ref.apply(this, arguments);
      }

      return extendSettingsFromDatabase;
    }(), 15);
  }
}