'use strict';

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _jsxFileName = 'vclass.js';

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactApollo = require('react-apollo');

var _head = require('next/dist/lib/head.js');

var _head2 = _interopRequireDefault(_head);

var _init = require('./init.js');

var _router = require('./router.js');

var _nprogress = require('./nprogress.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getComponentDisplayName(Component) {
  return Component.displayName || Component.name || 'Unknown';
}

// app provider function
// 返回一個 react component class (WithAppProvider)
function appProvider(ComposedComponent) {
  var _class, _temp;

  var modules = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  // modules 變數可以接受單一個 module, 或 modules array
  modules = Array.isArray(modules) ? modules : [modules];

  // 返回一個 react component class (WithAppProvider)
  return _temp = _class = function (_React$Component) {
    (0, _inherits3.default)(WithAppProvider, _React$Component);
    (0, _createClass3.default)(WithAppProvider, null, [{
      key: 'getInitialProps',


      // 何時會執行 getInitialProps
      // 當 server 要 render page 時
      // 當 client 轉頁時
      value: function () {
        var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx) {
          var initialState, dev, settings, composedInitialProps, loginToken, me, ssr, _blank, server, app, newContext, defaultModules, appModules, startupHooks, hook, readyHooks, _hook, url, composedNewProps, _app, _newContext;

          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  initialState = {};
                  dev = false;
                  settings = {};
                  composedInitialProps = {};
                  loginToken = void 0;
                  me = null;
                  ssr = true;

                  // 令 _blank 為 true 會將 render 輸出 null

                  _blank = false;

                  // getInitialProps 正在 server side 執行

                  if (!(typeof window === 'undefined')) {
                    _context.next = 57;
                    break;
                  }

                  // 由 req 中讀取 server
                  server = ctx.req.vclass.server;

                  // 1. dev 由 server 中得知

                  dev = server.dev;

                  // 2. settings 由 server 中得知
                  settings = {
                    public: server.settings.public || {}

                    // 3. me 由 req 中得知, 因為 accounts 已處理過
                  };me = ctx.req.vclass.me || null;

                  // 4. loginToken 會由 req cookies 傳送過來, 因為 server 已經有 cookieParser
                  loginToken = ctx.req.cookies[server.getSetting('cookiesLoginTokenKey')];

                  // 建立一個新 app, 將 app 儲存到 req
                  app = (0, _init.initApp)({ dev: dev, settings: settings });

                  ctx.req.vclass.app = app;

                  // 在 getInitialProps ctx 原有的基礎上, 加入其他變數成為新的 newContext
                  // 作為 modules, hooks 的 context
                  newContext = (0, _extends3.default)({
                    initialState: initialState, // apollo initial state
                    dev: dev, // dev
                    settings: settings, // settings
                    app: app,
                    loginToken: loginToken, // for auth
                    me: me, // me
                    ssr: ssr
                  }, ctx);

                  // 整合所有 modules

                  defaultModules = require('./modules/index.js');
                  appModules = [].concat((0, _toConsumableArray3.default)(defaultModules), (0, _toConsumableArray3.default)(modules));
                  // 執行所有 modules

                  appModules.forEach(function (module) {
                    if (typeof module === 'function') {
                      module(app, newContext);
                    }
                  });

                  // 暫存 _startup 作日後 debug 用
                  app.callbacks._startup = [].concat((0, _toConsumableArray3.default)(app.callbacks.startup || []));
                  startupHooks = app.callbacks.startup || [];
                  // 執行所有 startup hooks

                case 22:
                  if (!startupHooks.length) {
                    _context.next = 28;
                    break;
                  }

                  hook = startupHooks.shift();
                  _context.next = 26;
                  return hook(app, newContext);

                case 26:
                  _context.next = 22;
                  break;

                case 28:

                  // 為 app 創建 apolloclient
                  (0, _init.initApolloClient)(app, { initialState: initialState, loginToken: loginToken });

                  // 暫存 _ready 作日後 debug 用
                  app.callbacks._ready = [].concat((0, _toConsumableArray3.default)(app.callbacks.ready || []));
                  readyHooks = app.callbacks.ready || [];
                  // 執行所有 ready hooks

                case 31:
                  if (!readyHooks.length) {
                    _context.next = 37;
                    break;
                  }

                  _hook = readyHooks.shift();
                  _context.next = 35;
                  return _hook(app, newContext);

                case 35:
                  _context.next = 31;
                  break;

                case 37:
                  if (!ComposedComponent.getInitialProps) {
                    _context.next = 41;
                    break;
                  }

                  _context.next = 40;
                  return ComposedComponent.getInitialProps(newContext);

                case 40:
                  composedInitialProps = _context.sent;

                case 41:

                  // Provide the `url` prop data in case a graphql query uses it
                  url = {
                    query: ctx.query,
                    pathname: ctx.pathname,
                    asPath: ctx.asPath

                    // 為被包住的 component 新增 react context
                  };
                  ComposedComponent.contextTypes = _underscore2.default.extend(ComposedComponent.contextTypes || {}, {
                    client: _propTypes2.default.object,
                    app: _propTypes2.default.object,
                    Components: _propTypes2.default.object
                  });

                  // 新增 react props
                  // 被包住 component 有新的 props
                  // 包括 composedInitialProps 和 app, client, Components
                  composedNewProps = (0, _extends3.default)({}, composedInitialProps, {
                    url: url,
                    app: app,
                    client: app.apolloClient,
                    Components: app.components

                    // render 一次為了拿取 initial state
                  });
                  _context.prev = 44;
                  _context.next = 47;
                  return (0, _reactApollo.getDataFromTree)(_react2.default.createElement(
                    AppProvider,
                    { app: app, url: url, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 141
                      }
                    },
                    _react2.default.createElement(
                      _reactApollo.ApolloProvider,
                      { client: app.apolloClient, __source: {
                          fileName: _jsxFileName,
                          lineNumber: 142
                        }
                      },
                      _react2.default.createElement(ComposedComponent, (0, _extends3.default)({}, composedNewProps, {
                        __source: {
                          fileName: _jsxFileName,
                          lineNumber: 143
                        }
                      }))
                    )
                  ));

                case 47:
                  _context.next = 52;
                  break;

                case 49:
                  _context.prev = 49;
                  _context.t0 = _context['catch'](44);
                  console.log(_context.t0);

                case 52:

                  // console.log(app.apolloClient.store.getCache().extract())

                  _head2.default.rewind();

                  // 得到 initialState
                  try {
                    initialState = app.apolloClient.store.getCache().extract() || {};
                  } catch (__) {}

                  // 更正 setttings 應該由 app 中取得
                  // 有機會 client 在 server settings 上加多啲野
                  settings = {
                    public: app.settings.public || {}

                    // getInitialProps 正在 client side 執行
                  };_context.next = 77;
                  break;

                case 57:
                  _context.prev = 57;

                  // 讀取前一個 page 產生的 app
                  _app = (0, _init.initApp)();

                  // 1. 由該 app 讀取 initialState

                  try {
                    initialState = _app.apolloClient.store.getCache().extract() || {};
                  } catch (__) {}

                  // 2. 由 initialState 中 讀取 me
                  if (_app.getMeFromStore) {
                    me = _app.getMeFromStore();
                  }

                  // 3. dev 由 app 中拿取
                  dev = _app.dev;

                  // 4. settings 由 app 中拿取
                  settings = _app.settings;

                  // 由於 client 沒有 req
                  // 因為自己在 ctx 整一個差唔多的
                  ctx.vclass = {
                    app: _app,
                    me: me,
                    user: me,
                    userId: me && me._id
                  };

                  ssr = false;

                  // 在 getInitialProps ctx 原有的基礎上, 加入其他變數成為新的 newContext
                  // 作為 modules, hooks 的 context
                  _newContext = (0, _extends3.default)({
                    initialState: initialState, // apollo initial state
                    dev: dev, // dev
                    settings: settings, // settings
                    app: _app,
                    loginToken: loginToken, // for auth
                    me: me, // me
                    ssr: ssr
                  }, ctx);

                  // 5. 若果被包住的 component 有 getInitialProps function
                  // 也將 newContext 傳給 ComposedComponent.getInitialProps

                  if (!ComposedComponent.getInitialProps) {
                    _context.next = 70;
                    break;
                  }

                  _context.next = 69;
                  return ComposedComponent.getInitialProps(_newContext);

                case 69:
                  composedInitialProps = _context.sent;

                case 70:
                  _context.next = 77;
                  break;

                case 72:
                  _context.prev = 72;
                  _context.t1 = _context['catch'](57);

                  console.log('> getInitialProps error (client)', _context.t1);
                  // 有錯誤強制重新整理
                  window.location.reload();
                  // render 空白頁
                  _blank = true;

                case 77:
                  return _context.abrupt('return', (0, _extends3.default)({
                    initialState: initialState,
                    dev: dev,
                    settings: settings,
                    loginToken: loginToken,
                    // 由 ssr 或者 client 轉頁得出的 me 物件僅保留 _id, 如果登入了 initialState 已經有 me, 因此不用重複傳送 me
                    me: me && { _id: me._id },
                    _blank: _blank,
                    ssr: ssr
                  }, composedInitialProps));

                case 78:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[44, 49], [57, 72]]);
        }));

        function getInitialProps(_x2) {
          return _ref.apply(this, arguments);
        }

        return getInitialProps;
      }()

      // WithAppProvider class constructor

    }]);

    function WithAppProvider(props) {
      (0, _classCallCheck3.default)(this, WithAppProvider);

      // 若被要求空白頁，即唔會任何野了
      var _this = (0, _possibleConstructorReturn3.default)(this, (WithAppProvider.__proto__ || (0, _getPrototypeOf2.default)(WithAppProvider)).call(this, props));

      if (_this.props._blank) return (0, _possibleConstructorReturn3.default)(_this);

      var dev = props.dev,
          settings = props.settings,
          initialState = props.initialState,
          loginToken = props.loginToken;

      // 若是 client side, 創立新 app 之前先嘗試保留 oldApp

      var oldApp = void 0;
      try {
        oldApp = (0, _init.initApp)();
      } catch (__) {}

      // 強制創建新 app
      var app = (0, _init.initApp)({ dev: dev, settings: settings }, { force: true });

      if (app !== _this.app) {
        // 準備好 newContext 用於 modules 和 hooks
        var newContext = (0, _extends3.default)({}, props, { // initialState, dev, settings, loginToken, me(_id), ssr
          app: app,
          oldApp: oldApp,
          pathname: props.url.pathname,
          query: props.url.query,
          asPath: props.url.asPath

          // 執行所有 modules
        });var defaultModules = require('./modules/index.js');
        var appModules = [].concat((0, _toConsumableArray3.default)(defaultModules), (0, _toConsumableArray3.default)(modules));
        appModules.forEach(function (module) {
          if (typeof module === 'function') {
            module(app, newContext);
          }
        });

        // 執行所有 startup hooks
        app.callbacks._startup = [].concat((0, _toConsumableArray3.default)(app.callbacks.startup || []));
        var startupHooks = app.callbacks.startup || [];
        while (startupHooks.length) {
          var hook = startupHooks.shift();
          hook(app, newContext);
        }

        // server side 需要用到來自 req cookies 的 loginToken
        if (typeof window === 'undefined') {
          (0, _init.initApolloClient)(app, { initialState: initialState, loginToken: loginToken });
        } else {
          // client side 只需要 localstorage 的 loginToken
          (0, _init.initApolloClient)(app, { initialState: initialState });
        }

        // 執行所有 ready hooks
        app.callbacks._ready = [].concat((0, _toConsumableArray3.default)(app.callbacks.ready || []));
        var readyHooks = app.callbacks.ready || [];
        while (readyHooks.length) {
          var _hook2 = readyHooks.shift();
          _hook2(app, newContext);
        }
      }
      _this.app = app;

      // 設置被包住 component 的 react context
      ComposedComponent.contextTypes = _underscore2.default.extend(ComposedComponent.contextTypes || {}, {
        client: _propTypes2.default.object,
        app: _propTypes2.default.object,
        Components: _propTypes2.default.object
      });
      return _this;
    }

    (0, _createClass3.default)(WithAppProvider, [{
      key: 'render',
      value: function render() {
        console.log('WithAppProvider render', new Date());

        // 空白頁 ?!
        if (this.props._blank) return null;

        // 標題
        var title = this.app.getSetting('title');
        // meta description
        var description = this.app.getSetting('tagline') || this.app.getSetting('description');

        // 被包住 component 宣告新 props
        var composedNewProps = (0, _extends3.default)({}, this.props, {
          app: this.app,
          client: this.app.apolloClient,
          Components: this.app.components
        });

        return _react2.default.createElement(
          AppProvider,
          { app: this.app, url: this.props.url, __source: {
              fileName: _jsxFileName,
              lineNumber: 330
            }
          },
          _react2.default.createElement(
            _head2.default,
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 331
              }
            },
            title && _react2.default.createElement(
              'title',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 332
                }
              },
              title
            ),
            description && _react2.default.createElement('meta', { name: 'description', content: description, __source: {
                fileName: _jsxFileName,
                lineNumber: 333
              }
            }),
            _react2.default.createElement('meta', { name: 'viewport', content: 'width=device-width, initial-scale=1', __source: {
                fileName: _jsxFileName,
                lineNumber: 334
              }
            }),
            _react2.default.createElement(
              'style',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 335
                }
              },
              '' + _nprogress.nprogressStyle
            )
          ),
          _react2.default.createElement(
            _reactApollo.ApolloProvider,
            { client: this.app.apolloClient, __source: {
                fileName: _jsxFileName,
                lineNumber: 337
              }
            },
            _react2.default.createElement(ComposedComponent, (0, _extends3.default)({}, composedNewProps, {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 338
              }
            }))
          )
        );
      }
    }]);
    return WithAppProvider;
  }(_react2.default.Component), _class.displayName = 'WithAppProvider(' + getComponentDisplayName(ComposedComponent) + ')', _temp;
}

var AppProvider = function (_React$Component2) {
  (0, _inherits3.default)(AppProvider, _React$Component2);

  function AppProvider() {
    (0, _classCallCheck3.default)(this, AppProvider);
    return (0, _possibleConstructorReturn3.default)(this, (AppProvider.__proto__ || (0, _getPrototypeOf2.default)(AppProvider)).apply(this, arguments));
  }

  (0, _createClass3.default)(AppProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        app: this.props.app,
        Components: this.props.app.components,
        url: this.props.url
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 363
          }
        },
        this.props.children
      );
    }
  }]);
  return AppProvider;
}(_react2.default.Component);

AppProvider.childContextTypes = {
  app: _propTypes2.default.object,
  Components: _propTypes2.default.object,
  url: _propTypes2.default.object
};


var Export = {
  appProvider: appProvider,
  routerEmitter: _router.routerEmitter
};

Export._export = Export;

module.exports = Export;