'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

exports.default = eventEmitter;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function eventEmitter(events) {
  events = events || (0, _create2.default)(null);
  return {
    on: function on(name, func) {
      // console.log('eventEmitter - on', name, func)
      events[name] = events[name] || [];
      events[name].push(func);
    },
    off: function off(name, func) {
      // console.log('eventEmitter - off', name, func)
      if (events[name]) {
        events[name].splice(events[name].indexOf(func) >>> 0, 1);
      }
    },
    emit: function emit(name, args) {
      // console.log('eventEmitter - emit', name, args, events[name]);
      (events[name] || []).map(function (f) {
        f(args);
      });
      (events['*'] || []).map(function (f) {
        f(name, args);
      });
    }
  };
}