'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.default = callbacksModule;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function callbacksModule(root) {
  root.callbacks = {};

  _underscore2.default.extend(root.constructor.prototype, {
    addCallback: function addCallback(hook, callback, order) {
      if (!callback.name) {
        // console.log(`// Warning! You are adding an unnamed callback to ${hook}.Please use the function foo () {} syntax.`)
      }
      order = order || callback._callback_order || 100;

      this.callbacks[hook] = this.callbacks[hook] || [];
      var hookCallbacks = this.callbacks[hook];

      var i = 0;
      while (hookCallbacks[i] && hookCallbacks[i]._callback_order <= order) {
        i++;
      }

      if (!callback._callback_order) {
        callback._callback_order = order;
      }
      hookCallbacks.splice(i, 0, callback);
    },
    removeCallback: function removeCallback(hookName, callbackName) {
      this.callbacks[hookName] = _underscore2.default.reject(this.callbacks[hookName], function (callback) {
        return callback.name === callbackName;
      });
    },
    runCallbacks: function runCallbacks(hook, item) {
      for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
      }

      var _this = this;

      var hookCallbacks = Array.isArray(hook) ? hook : this.callbacks[hook];
      if (hookCallbacks && hookCallbacks.length) {
        return hookCallbacks.reduce(function (accumulator, callback) {
          try {
            var result = callback.apply(_this, [accumulator].concat((0, _toConsumableArray3.default)(args)));
            if (typeof result === 'undefined') {
              console.log('// Warning: Sync callback [' + callback.name + '] in hook [' + hook + '] didn\'t return a result!');
              return accumulator;
            } else {
              return result;
            }
          } catch (error) {
            console.log('// error at callback [' + callback.name + '] in hook [' + hook + ']');
            console.log(error);

            if (error.break || error.data && error.data.break) {
              throw error;
            }

            return accumulator;
          }
        }, item);
      }
      return item;
    },
    runCallbacksSync: function runCallbacksSync(hook, item) {
      for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
        args[_key2 - 2] = arguments[_key2];
      }

      return this.runCallbacks.apply(this, [hook, item].concat((0, _toConsumableArray3.default)(args)));
    },


    // runCallbacksAsync, 跟上面一樣, 但 return promise
    // 上層需要有 try catch 處理 runCallbacksAsync throw 的 error
    runCallbacksAsync: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(hook, item) {
        var hookCallbacks,
            accumulator,
            _len3,
            args,
            _key3,
            i,
            callback,
            result,
            _args = arguments;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                hookCallbacks = Array.isArray(hook) ? hook : this.callbacks[hook];

                if (!(hookCallbacks && hookCallbacks.length)) {
                  _context.next = 24;
                  break;
                }

                accumulator = item;

                for (_len3 = _args.length, args = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
                  args[_key3 - 2] = _args[_key3];
                }

                i = 0;

              case 5:
                if (!(i < hookCallbacks.length)) {
                  _context.next = 23;
                  break;
                }

                callback = hookCallbacks[i];
                _context.prev = 7;
                _context.next = 10;
                return callback.apply(this, [accumulator].concat((0, _toConsumableArray3.default)(args)));

              case 10:
                result = _context.sent;

                if (typeof result === 'undefined') {
                  console.log('// Warning: Async callback [' + callback.name + '] in hook [' + hook + '] didn\'t return a result!');
                } else {
                  accumulator = result;
                }
                _context.next = 20;
                break;

              case 14:
                _context.prev = 14;
                _context.t0 = _context['catch'](7);

                console.log('// error at callback [' + callback.name + '] in hook [' + hook + ']');
                console.log(_context.t0);

                if (!(_context.t0.break || _context.t0.data && _context.t0.data.break)) {
                  _context.next = 20;
                  break;
                }

                throw _context.t0;

              case 20:
                i++;
                _context.next = 5;
                break;

              case 23:
                return _context.abrupt('return', accumulator);

              case 24:
                return _context.abrupt('return', item);

              case 25:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[7, 14]]);
      }));

      function runCallbacksAsync(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return runCallbacksAsync;
    }()
  });
}