'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = settingsModule;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function settingsModule(root, _ref) {
  var _ref$settings = _ref.settings,
      settings = _ref$settings === undefined ? {} : _ref$settings;

  // 預設 settings
  var defaultSettings = {
    public: {
      localStorageUserIdKey: 'V.userId',
      localStorageLoginTokenKey: 'V.loginToken',
      loginTokenExpiresKey: 'V.loginTokenExpires',
      cookiesLoginTokenKey: 'v_login_token',
      headerLoginTokenKey: 'v-login-token',
      title: 'V',
      tagline: '',
      description: ''
    }

    // 整合 options settings
  };root.settings = (0, _extend2.default)(true, {}, defaultSettings, settings);

  _underscore2.default.extend(root.constructor.prototype, {
    getSetting: function getSetting(name, defaultValue) {
      var rootSetting = this.settings[name];
      var privateSetting = this.settings.private && this.settings.private[name];
      var publicSetting = this.settings.public && this.settings.public[name];

      if ((typeof rootSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(rootSetting)) === 'object' && !Array.isArray(rootSetting) || (typeof privateSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(privateSetting)) === 'object' && !Array.isArray(privateSetting) || (typeof publicSetting === 'undefined' ? 'undefined' : (0, _typeof3.default)(publicSetting)) === 'object' && !Array.isArray(publicSetting)) {
        return (0, _extend2.default)(true, {}, rootSetting, privateSetting, publicSetting, defaultValue);
      } else {
        if (privateSetting !== undefined) return privateSetting;else if (publicSetting !== undefined) return publicSetting;else if (rootSetting !== undefined) return rootSetting;
        return defaultValue;
      }
    }
  });
}