'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

exports.default = urlModule;

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function urlModule(root) {
  _underscore2.default.extend(root.constructor.prototype, {
    absoluteUrl: function absoluteUrl(path, options) {
      if (!options && (typeof path === 'undefined' ? 'undefined' : (0, _typeof3.default)(path)) === 'object') {
        options = path;
        path = undefined;
      }

      options = options || {};
      options = (0, _extends3.default)({
        rootUrl: this.getSetting('rootUrl')
      }, options);

      var url = options.rootUrl;
      if (!url) {
        throw new Error(500, 'Must pass options.rootUrl or set rootUrl in the settings');
      }

      if (!/^http[s]?:\/\//i.test(url)) {
        url = 'http://' + url;
      }

      if (!/\/$/.test(url)) {
        url += '/';
      }

      if (path) {
        url += path;
      }

      if (options.secure && /^http:/.test(url) && !/http:\/\/localhost[:/]/.test(url) && !/http:\/\/127\.0\.0\.1[:/]/.test(url)) {
        url = url.replace(/^http:/, 'https:');
      }

      if (options.replaceLocalhost) {
        url = url.replace(/^http:\/\/localhost([:/].*)/, 'http://127.0.0.1$1');
      }

      return url;
    }
  });
}