'use strict';

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

var _graphqlTypeJson = require('graphql-type-json');

var _graphqlTypeJson2 = _interopRequireDefault(_graphqlTypeJson);

var _graphqlDate = require('graphql-date');

var _graphqlDate2 = _interopRequireDefault(_graphqlDate);

var _index = require('./index.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function graphqlSchemaModule(server) {
  // 新增 server.graphqlSchemaObj
  server.graphqlSchemaObj = {
    schemas: [],
    queryFields: [],
    mutationFields: []
    // 預設 resolvers 有 JSON 和 Date
  };server.graphqlResolvers = {
    JSON: _graphqlTypeJson2.default,
    Date: _graphqlDate2.default
    // 預設 graphqlContext 有 server 和 collections
  };server.graphqlContext = {
    server: server,
    collections: server.collections
  };

  _underscore2.default.extend(server.constructor.prototype, {
    // 新增 graphql schema
    addGraphqlSchema: function addGraphqlSchema(schema) {
      this.graphqlSchemaObj.schemas.push(schema);
    },


    // 新增 graphql query field
    addGraphqlQueryField: function addGraphqlQueryField(query) {
      this.graphqlSchemaObj.queryFields.push(query);
    },


    // 新增 graphql mutation field
    addGraphqlMutationField: function addGraphqlMutationField(mutation) {
      this.graphqlSchemaObj.mutationFields.push(mutation);
    },


    // extend graphql resolvers
    addGraphqlResolvers: function addGraphqlResolvers(resolvers) {
      (0, _extend2.default)(true, this.graphqlResolvers, resolvers);
    },


    // extend graphql context
    addToGraphqlContext: function addToGraphqlContext(object) {
      (0, _extend2.default)(true, this.graphqlContext, object);
    }
  });
}

(0, _index.addModule)(graphqlSchemaModule);